package com.example.roottoggle

import android.os.Bundle
import android.widget.Button
import androidx.activity.enableEdgeToEdge
import androidx.appcompat.app.AppCompatActivity
import androidx.core.view.ViewCompat
import androidx.core.view.WindowInsetsCompat
import com.topjohnwu.superuser.Shell

class MainActivity : AppCompatActivity() {
    private lateinit var toggleButton: Button

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        toggleButton = findViewById(R.id.toggleButton)

        checkCurrentRootAccess()

        toggleButton.setOnClickListener {
            toggleRootAccess()
        }
    }

    private fun checkCurrentRootAccess() {
        Shell.cmd("getprop persist.sys.root_access").submit { result ->
            val currentStatus = result.out.joinToString("")
            toggleButton.text = if (currentStatus == "1") "Disable Root Access" else "Enable Root Access"
        }
    }

    private fun toggleRootAccess() {
        Shell.cmd("getprop persist.sys.root_access").submit { result ->
            val currentStatus = result.out.joinToString("")
            val newStatus = if (currentStatus == "1") "0" else "1"

            Shell.cmd("setprop persist.sys.root_access $newStatus").submit { toggleResult ->
                if (toggleResult.isSuccess) {
                    toggleButton.text = if (newStatus == "1") "Disable Root Access" else "Enable Root Access"
                } else {
                    toggleButton.text = "Failed to Toggle"
                }
            }
        }
    }
}